<?php
class Gateway {
	private $_config;
	private $_module;
	private $_basket;
	private $_vendorTxCode;
	private $_url;

	public function __construct($module = false, $basket = false) {
		$this->_session	=& $GLOBALS['user'];

		$this->_module			= $module;
		$this->_basket			= $basket;
		$this->_vendorTxCode 	= md5(randomPass(3).time().rand(0,32000)).randomPass(8);
		if($this->_module['gate'] == "sim") {
			$this->_url = "https://test.sagepay.com/Simulator/VSPFormGateway.asp";
		} elseif($this->_module['gate'] == "test") {
			$this->_url = "https://test.sagepay.com/gateway/service/vspform-register.vsp";
		} elseif($this->_module['gate'] == "live"){
			$this->_url = "https://live.sagepay.com/gateway/service/vspform-register.vsp";
		} 
	}

	private function simpleXor($InString, $Key) {
		$KeyList = array();
		$output = "";
		for($i = 0; $i < strlen($Key); $i++) {
			$KeyList[$i] = ord(substr($Key, $i, 1));
		}
		for($i = 0; $i < strlen($InString); $i++) {
	    	$output.= chr(ord(substr($InString, $i, 1)) ^ ($KeyList[$i % strlen($Key)]));
	  	}
	  	return $output;
	}

	private function getToken($thisString) {

		$Tokens = array(
		    "Status",
		    "StatusDetail",
		    "VendorTxCode",
		    "VPSTxId",
		    "TxAuthNo",
		    "Amount",
		    "AVSCV2",
		    "AddressResult",
		    "PostCodeResult",
		    "CV2Result",
		    "GiftAid",
		    "3DSecureStatus",
		    "CAVV" );

		$output = array();
		$resultArray = array();
		for ($i = count($Tokens)-1; $i >= 0 ; $i--) {
			$start = strpos($thisString, $Tokens[$i]);
	    	if ($start !== false) {
	      		$resultArray[$i]->start = $start;
	      		$resultArray[$i]->token = $Tokens[$i];
	    	}
	    }

		sort($resultArray);
	  	for ($i = 0; $i<count($resultArray); $i++) {
	  		$valueStart = $resultArray[$i]->start + strlen($resultArray[$i]->token) + 1;
			if ($i==(count($resultArray)-1)) {
	    		$output[$resultArray[$i]->token] = substr($thisString, $valueStart);
	    	} else {
	    		$valueLength = $resultArray[$i+1]->start - $resultArray[$i]->start - strlen($resultArray[$i]->token) - 2;
				$output[$resultArray[$i]->token] = substr($thisString, $valueStart, $valueLength);
	    	}
	 	}
	  return $output;
	}

	public function transfer() {

		$transfer	= array(
			'action'	=> $this->_url,
			'method'	=> 'post',
			'target'	=> '_self',
			'submit'	=> ($this->_module['iframe']) ? 'iframe' : 'auto',
		);
		return $transfer;
	}

	public function repeatVariables() {
		return false;
	}
	
	public function iframeURL() {
		$repeat_vars 	= $this->repeatVariables();
		if(is_array($repeat_vars)) {
			$request_vars = array_merge($this->fixedVariables(),$this->repeatVariables());
		} else {
			$request_vars = $this->fixedVariables();
		}
		return ($request_vars) ? $this->_url.'?'.http_build_query($request_vars, '', '&') : false;	
	}

	public function fixedVariables() {

		$cryptVars =
		"VendorTxCode=".$this->_vendorTxCode
		."&Amount=".$this->_basket['total']
		."&Currency=".$GLOBALS['config']->get('config', 'default_currency')
		."&Description=Cart - ".$this->_basket['cart_order_id']
		."&CustomerEmail=".$this->_basket['billing_address']['email']
		."&CustomerName=".$this->_basket['billing_address']['first_name']." ".$this->_basket['billing_address']['last_name']
		#."&VendorEmail=".$GLOBALS['config']->get('config', 'email_address')
		."&ApplyAVSCV2=0&Apply3DSecure=0"
		."&SuccessURL=".$GLOBALS['storeURL'].'/index.php?_g=rm&type=gateway&cmd=process&module=SagePay&cart_order_id='.$this->_basket['cart_order_id']
		."&FailureURL=".$GLOBALS['storeURL'].'/index.php?_g=rm&type=gateway&cmd=process&module=SagePay&cart_order_id='.$this->_basket['cart_order_id']
		."&BillingSurname=".$this->_basket['billing_address']['last_name']
		."&BillingFirstnames=".$this->_basket['billing_address']['first_name']
		."&BillingAddress1=".$this->_basket['billing_address']['line1']
		."&BillingAddress2=".$this->_basket['billing_address']['line2']
		."&BillingCity=".$this->_basket['billing_address']['town']
		."&BillingCountry=".$this->_basket['billing_address']['country_iso']
		."&BillingPostCode=".$this->_basket['delivery_address']['postcode']
		."&BillingPhone=".$this->_basket['billing_address']['phone']
		."&DeliverySurname=".$this->_basket['delivery_address']['last_name']
		."&DeliveryFirstnames=".$this->_basket['delivery_address']['first_name']
		."&DeliveryAddress1=".$this->_basket['delivery_address']['line1']
		."&DeliveryAddress2=".$this->_basket['delivery_address']['line2']
		."&DeliveryCity=".$this->_basket['delivery_address']['town']
		."&DeliveryPostCode=".$this->_basket['delivery_address']['postcode']
		."&DeliveryCountry=".$this->_basket['delivery_address']['country_iso']
		."&DeliveryPhone=".$this->_basket['delivery_address']['phone']
		."&Basket="
		."&AllowGiftAid=0"
		."&SendEMail=1"
		."&Refferid={32839EA8-8935-49A4-95FB-369E755B632C}";

		if($this->_basket['delivery_address']['country_iso']=="US") {
			$cryptVars.="&BillingState=".$this->_basket['billing_address']['state_abbrev'];
		}
		if($this->_basket['delivery_address']['country_iso']=="US") {
			$cryptVars.="&DeliveryState=".$this->_basket['delivery_address']['state_abbrev'];
		}
		//echo $cryptVars.'<br />';

		$TxType	= empty($this->_module['TxType']) ? 'PAYMENT' : $this->_module['TxType'];

		$hidden		= 	array(
							'VendorTxCode' 	=> $this->_vendorTxCode,
							'VPSProtocol' 	=> '2.23',
							'TxType' 		=> $TxType,
							'Vendor'		=> $this->_module['acNo'],
							'Crypt'			=> base64_encode($this->SimpleXor($cryptVars,$this->_module['passphrase']))
						);
		return $hidden;
	}

	##################################################

	public function call() {
		return false;
	}

	public function process() {

		$Decoded 	= $this->SimpleXor(base64_decode($_REQUEST['crypt']),$this->_module['passphrase']);
		$values 	= $this->getToken($Decoded);
		$cart_order_id = sanitizeVar($_GET['cart_order_id']); // Used in remote.php $cart_order_id is important for failed orders

		$order				= Order::getInstance();
		$order_summary		= $order->getSummary($cart_order_id);

		$transData['customer_id'] 	= $order_summary["customer_id"];
		$transData['gateway'] 		= "SagePay";
		$transData['trans_id'] 		= $values["VendorTxCode"];
		$transData['amount'] 		= sprintf("%.2f",$values['Amount']);
		$transData['status'] 		= $values['Status'];
		$transData['order_id']		= $cart_order_id;

		if($values['Status']=="OK"){
			$order->orderStatus(Order::ORDER_PROCESS, $cart_order_id);
			$order->paymentStatus(Order::PAYMENT_SUCCESS, $cart_order_id);
			$transData['notes'] = $values['StatusDetail'];
		} else {
			$order->orderStatus(Order::ORDER_PENDING, $cart_order_id);
			$order->paymentStatus(Order::PAYMENT_PENDING, $cart_order_id);
			$transData['notes'] = $values['StatusDetail'];
		}
		$order->logTransaction($transData);
		httpredir(currentPage(array('_g', 'type', 'cmd', 'module'), array('_a' => 'complete')));
		return false;
	}

	public function form() {
		return false;
	}
}